/* com.cintegrity.Lib.Exception.TestExceptionStack.p */

define variable lhn_PP as handle no-undo.
define variable lob_ExceptionStack as class com.cintegrity.Lib.Exception.ExceptionStack no-undo.
define variable lin_Entry as integer no-undo.
define variable llc_ExceptionLog as longchar no-undo.
define variable lhn_XML as handle no-undo.

lob_ExceptionStack = new com.cintegrity.Lib.Exception.ExceptionStack().
run com/cintegrity/Lib/Exception/TestExceptionStackPP.p persistent set lhn_PP.

lob_ExceptionStack:trace( "Start of main program" ).

run A in lhn_PP.

If lob_ExceptionStack:numExceptions( 1 ) gt 0
then lob_ExceptionStack:trace( "Back from A with a fatal error" ).
else lob_ExceptionStack:trace( "Back from A with no fatal error" ).

if lob_ExceptionStack:numExceptions( 1 ) gt 0
then repeat:
  message lob_ExceptionStack:popException( 1 ) view-as alert-box.
  if lob_ExceptionStack:numExceptions( 1 ) eq 0 then leave.
end.

lob_ExceptionStack:trace( "Going into debug before going to B").
lob_ExceptionStack:setDebug().

run B in lhn_PP.

If lob_ExceptionStack:numExceptions( 4 ) gt 0
then lob_ExceptionStack:trace( "Back from B with one or more errors" ).
else lob_ExceptionStack:trace( "Back from B with no errors" ).

do lin_Entry = 1 to lob_ExceptionStack:numExceptions( 4 ):
  message lob_ExceptionStack:getExceptionNo( 4, lin_Entry ) view-as alert-box.
end.

if lob_ExceptionStack:numExceptions( 4 ) gt 0
then repeat:
  message lob_ExceptionStack:popException( 4 ) view-as alert-box.
  if lob_ExceptionStack:numExceptions( 4 ) eq 0 then leave.
end.

llc_ExceptionLog = lob_ExceptionStack:toLongString( 9 ).
output to "ExceptionLog.txt".
do lin_Entry = 1 to num-entries( llc_ExceptionLog, chr(1) ):
  put unformatted entry( lin_Entry, llc_ExceptionLog, chr(1) ) skip.
end.
output close.

llc_ExceptionLog = lob_ExceptionStack:writeExternal().
/*
create x-document lhn_XML.
lhn_XML:encoding = "UTF-8".
lhn_XML:load( "longchar", llc_ExceptionLog, false ).
lhn_XML:save( "file","ExceptionLog.xml" ).
*/
copy-lob llc_ExceptionLog to file "ExceptionLog.xml".

lob_ExceptionStack:clearExceptions().

message "After clear:  Number of exceptions = " lob_ExceptionStack:numExceptions( 5 ) view-as alert-box.

run destructPP in lhn_PP.
delete object lob_ExceptionStack.
lob_ExceptionStack = ?.
